diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/attribute.h ns-3.42/src/core/model/attribute.h
--- ns-3.41/src/core/model/attribute.h	2024-02-09 14:44:07.873789800 -0800
+++ ns-3.42/src/core/model/attribute.h	2024-05-29 15:29:46.928073200 -0700
@@ -226,9 +226,17 @@
 };
 
 /**
+ * \ingroup attributes
+ * \defgroup attribute_EmptyAttribute EmptyAttribute Attribute
+ * AttributeValue implementation for EmptyAttribute
+ */
+
+/**
  * \brief A class for an empty attribute value.
  *
- * \ingroup attributes
+ * \ingroup attribute_EmptyAttribute
+ *
+ * \see AttributeValue
  */
 class EmptyAttributeValue : public AttributeValue
 {
@@ -262,6 +270,8 @@
 /**
  * \brief An accessor for EmptyAttributeValue
  *
+ * \ingroup attribute_EmptyAttribute
+ *
  * Does nothing, since every EmptyAttributeValue is the same.
  */
 class EmptyAttributeAccessor : public AttributeAccessor
@@ -276,7 +286,7 @@
 };
 
 /**
- * \ingroup attributes
+ * \ingroup attribute_EmptyAttribute
  *
  * \brief Create an empty AttributeAccessor.
  *
@@ -291,6 +301,8 @@
 /**
  * \brief A checker for EmptyAttributeValue
  *
+ * \ingroup attribute_EmptyAttribute
+ *
  * Does nothing, since every EmptyAttributeValue does not contain anything and
  * is, of course, valid.
  */
@@ -308,7 +320,7 @@
 };
 
 /**
- * \ingroup attributes
+ * \ingroup attribute_EmptyAttribute
  *
  * \brief Create an empty AttributeChecker.
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/boolean.cc ns-3.42/src/core/model/boolean.cc
--- ns-3.41/src/core/model/boolean.cc	2024-02-09 14:44:07.873789800 -0800
+++ ns-3.42/src/core/model/boolean.cc	2024-05-29 15:29:46.928073200 -0700
@@ -24,7 +24,7 @@
 /**
  * \file
  * \ingroup attribute_Boolean
- * ns3::BooleanValue attribute value implementaation.
+ * ns3::BooleanValue attribute value implementation.
  */
 
 namespace ns3
@@ -38,7 +38,7 @@
     NS_LOG_FUNCTION(this);
 }
 
-BooleanValue::BooleanValue(bool value)
+BooleanValue::BooleanValue(const bool& value)
     : m_value(value)
 {
     NS_LOG_FUNCTION(this << value);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/boolean.h ns-3.42/src/core/model/boolean.h
--- ns-3.41/src/core/model/boolean.h	2024-02-09 14:44:07.873789800 -0800
+++ ns-3.42/src/core/model/boolean.h	2024-05-29 15:29:46.928073200 -0700
@@ -37,12 +37,7 @@
 {
   public:
     BooleanValue();
-    /**
-     * Construct from an explicit value.
-     *
-     * \param [in] value The boolean value to begin with.
-     */
-    BooleanValue(bool value);
+    BooleanValue(const bool& value);
     void Set(bool value);
     bool Get() const;
     template <typename T>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/callback.cc ns-3.42/src/core/model/callback.cc
--- ns-3.41/src/core/model/callback.cc	2024-02-09 14:44:07.873789800 -0800
+++ ns-3.42/src/core/model/callback.cc	2024-05-29 15:29:46.928073200 -0700
@@ -38,8 +38,8 @@
     NS_LOG_FUNCTION(this);
 }
 
-CallbackValue::CallbackValue(const CallbackBase& base)
-    : m_value(base)
+CallbackValue::CallbackValue(const CallbackBase& value)
+    : m_value(value)
 {
 }
 
@@ -49,11 +49,17 @@
 }
 
 void
-CallbackValue::Set(CallbackBase base)
+CallbackValue::Set(const CallbackBase& value)
 {
-    NS_LOG_FUNCTION(&base);
+    NS_LOG_FUNCTION(&value);
+    m_value = value;
+}
 
-    m_value = base;
+CallbackBase
+CallbackValue::Get()
+{
+    NS_LOG_FUNCTION(this);
+    return m_value;
 }
 
 Ptr<AttributeValue>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/callback.h ns-3.42/src/core/model/callback.h
--- ns-3.41/src/core/model/callback.h	2024-02-09 14:44:07.873789800 -0800
+++ ns-3.42/src/core/model/callback.h	2024-05-29 15:29:46.928073200 -0700
@@ -490,8 +490,10 @@
      * of the first argument is a class derived from CallbackBase (i.e., a Callback).
      */
     template <typename T,
-              std::enable_if_t<!std::is_base_of_v<CallbackBase, T>, int> = 0,
-              typename... BArgs>
+              typename... BArgs,
+              std::enable_if_t<!std::is_base_of_v<CallbackBase, T> &&
+                                   std::is_invocable_r_v<R, T, BArgs..., UArgs...>,
+                               int> = 0>
     Callback(T func, BArgs... bargs)
     {
         // store the function in a std::function object
@@ -648,18 +650,12 @@
      */
     bool DoCheckType(Ptr<const CallbackImplBase> other) const
     {
-        if (other && dynamic_cast<const CallbackImpl<R, UArgs...>*>(PeekPointer(other)) != nullptr)
+        if (!other)
         {
             return true;
         }
-        else if (!other)
-        {
-            return true;
-        }
-        else
-        {
-            return false;
-        }
+
+        return (dynamic_cast<const CallbackImpl<R, UArgs...>*>(PeekPointer(other)) != nullptr);
     }
 };
 
@@ -805,18 +801,12 @@
 class CallbackValue : public AttributeValue
 {
   public:
-    /** Constructor */
     CallbackValue();
-    /**
-     * Copy constructor
-     * \param [in] base Callback to copy
-     */
-    CallbackValue(const CallbackBase& base);
-    /** Destructor */
+    CallbackValue(const CallbackBase& value);
     ~CallbackValue() override;
-    /** \param [in] base The CallbackBase to use */
-    void Set(CallbackBase base);
-    /* Documented by print-introspected-doxygen.cc */
+    // Documented by print-introspected-doxygen.cc
+    void Set(const CallbackBase& value);
+    CallbackBase Get();
     template <typename T>
     bool GetAccessor(T& value) const;
     /** \return A copy of this CallBack */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/config.cc ns-3.42/src/core/model/config.cc
--- ns-3.41/src/core/model/config.cc	2024-02-09 14:44:07.873789800 -0800
+++ ns-3.42/src/core/model/config.cc	2024-05-29 15:29:46.932073000 -0700
@@ -30,10 +30,14 @@
 
 /**
  * \file
- * \ingroup config
+ * \ingroup config-impl
  * ns3::Config implementations.
  */
 
+/**
+ * \defgroup config-impl Config implementations
+ * \ingroup config
+ */
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/deprecated.h ns-3.42/src/core/model/deprecated.h
--- ns-3.41/src/core/model/deprecated.h	2024-02-09 14:44:07.873789800 -0800
+++ ns-3.42/src/core/model/deprecated.h	2024-05-29 15:29:46.932073000 -0700
@@ -22,12 +22,17 @@
 
 /**
  * \file
- * \ingroup core
+ * \ingroup deprecation
  * NS_DEPRECATED macro definition.
  */
 
 /**
+ * \defgroup deprecation Deprecation
  * \ingroup core
+ */
+
+/**
+ * \ingroup deprecation
  * \def NS_DEPRECATED
  * Mark a function as deprecated.
  *
@@ -36,8 +41,22 @@
  * When deprecating a feature, please update the documentation
  * with information for users on how to update their code.
  *
- * For example,
- * \snippet src/core/doc/deprecated-example.h doxygen snippet
+ * The following snippet shows an example of how to deprecate the function SomethingUseful()
+ * in favor of the new function TheNewWay().
+ * Note: in the following snippet, the Doxygen blocks are not following the ns-3 style.
+ * This allows the code to be safely embedded in the documentation.
+ *
+ * \code
+ * /// Do something useful.
+ * ///
+ * /// \deprecated This method will go away in future versions of ns-3.
+ * /// See instead TheNewWay().
+ * NS_DEPRECATED_3_XX("see TheNewWay")
+ * void SomethingUseful();
+ *
+ * /// Do something more useful.
+ * void TheNewWay();
+ * \endcode
  *
  * Please follow these two guidelines to ease future maintenance
  * (primarily the eventual removal of the deprecated code):
@@ -48,7 +67,8 @@
  * 2.  Typically only the declaration needs to be deprecated,
  *
  *     \code
- *     NS_DEPRECATED_3_XX ("see TheNewWay") void SomethingUseful ();
+ *     NS_DEPRECATED_3_XX("see TheNewWay")
+ *     void SomethingUseful();
  *     \endcode
  *
  *     but it's helpful to put the same macro as a comment
@@ -56,9 +76,9 @@
  *     all the bits which eventually have to be removed:
  *
  *     \code
- *     \/\* NS_DEPRECATED_3_XX ("see TheNewWay") *\\/
- *     void SomethingUseful () { ... }
- *     \endcode.
+ *     // NS_DEPRECATED_3_XX("see TheNewWay")
+ *     void SomethingUseful() { ... }
+ *     \endcode
  *
  * \note Sometimes it is necessary to silence a deprecation warning.
  * Even though this is highly discouraged, if necessary it is possible to use:
@@ -75,17 +95,24 @@
 #define NS_DEPRECATED(msg) [[deprecated(msg)]]
 
 /**
- * \ingroup core
+ * \ingroup deprecation
+ * \def NS_DEPRECATED_3_42
+ * Tag for things deprecated in version ns-3.42.
+ */
+#define NS_DEPRECATED_3_42(msg) NS_DEPRECATED("Deprecated in ns-3.42: " msg)
+
+/**
+ * \ingroup deprecation
  * \def NS_DEPRECATED_3_41
  * Tag for things deprecated in version ns-3.41.
  */
-#define NS_DEPRECATED_3_41(msg) NS_DEPRECATED(msg)
+#define NS_DEPRECATED_3_41(msg) NS_DEPRECATED("Deprecated in ns-3.41: " msg)
 
 /**
- * \ingroup core
+ * \ingroup deprecation
  * \def NS_DEPRECATED_3_40
  * Tag for things deprecated in version ns-3.40.
  */
-#define NS_DEPRECATED_3_40(msg) NS_DEPRECATED(msg)
+#define NS_DEPRECATED_3_40(msg) NS_DEPRECATED("Deprecated in ns-3.40: " msg)
 
 #endif /* NS3_DEPRECATED_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/enum.h ns-3.42/src/core/model/enum.h
--- ns-3.41/src/core/model/enum.h	2024-02-09 14:44:07.877790000 -0800
+++ ns-3.42/src/core/model/enum.h	2024-05-29 15:29:46.932073000 -0700
@@ -62,12 +62,7 @@
 {
   public:
     EnumValue();
-    /**
-     * Construct from an explicit value.
-     *
-     * \param [in] value The value to begin with.
-     */
-    EnumValue(T value);
+    EnumValue(const T& value);
     void Set(T value);
     T Get() const;
 
@@ -78,14 +73,14 @@
     bool DeserializeFromString(std::string value, Ptr<const AttributeChecker> checker) override;
 
   private:
-    T m_value; //!< The stored value.
+    T m_value{}; //!< The stored value.
 };
 
 template <typename T>
 EnumValue<T>::EnumValue() = default;
 
 template <typename T>
-EnumValue<T>::EnumValue(T value)
+EnumValue<T>::EnumValue(const T& value)
     : m_value(value)
 {
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/event-id.cc ns-3.42/src/core/model/event-id.cc
--- ns-3.41/src/core/model/event-id.cc	2024-02-09 14:44:07.877790000 -0800
+++ ns-3.42/src/core/model/event-id.cc	2024-05-29 15:29:46.932073000 -0700
@@ -73,12 +73,18 @@
 }
 
 bool
-EventId::IsRunning() const
+EventId::IsPending() const
 {
     NS_LOG_FUNCTION(this);
     return !IsExpired();
 }
 
+bool
+EventId::IsRunning() const
+{
+    return IsPending();
+}
+
 EventImpl*
 EventId::PeekEventImpl() const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/event-id.h ns-3.42/src/core/model/event-id.h
--- ns-3.41/src/core/model/event-id.h	2024-02-09 14:44:07.877790000 -0800
+++ ns-3.42/src/core/model/event-id.h	2024-05-29 15:29:46.932073000 -0700
@@ -19,6 +19,7 @@
 #ifndef EVENT_ID_H
 #define EVENT_ID_H
 
+#include "deprecated.h"
 #include "event-impl.h"
 #include "ptr.h"
 
@@ -47,7 +48,7 @@
  * The important thing to remember about this class is that
  * every variable of this type is _always_ in a valid state,
  * even when it has not been assigned an EventId coming from a
- * Simulator::Schedule() method:  calling Simulator::Cancel(), IsRunning(),
+ * Simulator::Schedule() method:  calling Simulator::Cancel(), IsPending(),
  * IsExpired() or passing around instances of this object
  * will not result in crashes or memory leaks.
  */
@@ -101,6 +102,14 @@
      *
      * \returns \c true if the event has not expired, \c false otherwise.
      */
+    bool IsPending() const;
+
+    /**
+     * This method is syntactic sugar for !IsExpired().
+     *
+     * \returns \c true if the event has not expired, \c false otherwise.
+     */
+    NS_DEPRECATED_3_42("Use IsPending instead")
     bool IsRunning() const;
 
   public:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/example-as-test.cc ns-3.42/src/core/model/example-as-test.cc
--- ns-3.41/src/core/model/example-as-test.cc	2024-02-09 14:44:07.877790000 -0800
+++ ns-3.42/src/core/model/example-as-test.cc	2024-05-29 15:29:46.932073000 -0700
@@ -153,9 +153,9 @@
                                        const std::string program,
                                        const std::string dataDir,
                                        const std::string args /* = "" */,
-                                       const TestDuration duration /* =QUICK */,
+                                       const Duration duration /* =QUICK */,
                                        const bool shouldNotErr /* = true */)
-    : TestSuite(name, EXAMPLE)
+    : TestSuite(name, Type::EXAMPLE)
 {
     NS_LOG_FUNCTION(this << name << program << dataDir << args << duration << shouldNotErr);
     AddTestCase(new ExampleAsTestCase(name, program, dataDir, args, shouldNotErr), duration);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/example-as-test.h ns-3.42/src/core/model/example-as-test.h
--- ns-3.41/src/core/model/example-as-test.h	2024-02-09 14:44:07.877790000 -0800
+++ ns-3.42/src/core/model/example-as-test.h	2024-05-29 15:29:46.932073000 -0700
@@ -218,7 +218,7 @@
                        const std::string program,
                        const std::string dataDir,
                        const std::string args = "",
-                       const TestDuration duration = QUICK,
+                       const Duration duration = Duration::QUICK,
                        const bool shouldNotErr = true);
 }; // class ExampleAsTestSuite
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/global-value.h ns-3.42/src/core/model/global-value.h
--- ns-3.41/src/core/model/global-value.h	2024-02-09 14:44:07.877790000 -0800
+++ ns-3.42/src/core/model/global-value.h	2024-05-29 15:29:46.932073000 -0700
@@ -41,7 +41,7 @@
 }
 
 /**
- * \ingroup Core
+ * \ingroup core
  *
  * \brief Hold a so-called 'global value'.
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/int64x64-128.cc ns-3.42/src/core/model/int64x64-128.cc
--- ns-3.41/src/core/model/int64x64-128.cc	2024-02-09 14:44:07.877790000 -0800
+++ ns-3.42/src/core/model/int64x64-128.cc	2024-05-29 15:29:46.932073000 -0700
@@ -52,8 +52,8 @@
 {
     bool negA = sa < 0;
     bool negB = sb < 0;
-    ua = negA ? -sa : sa;
-    ub = negB ? -sb : sb;
+    ua = negA ? -static_cast<uint128_t>(sa) : sa;
+    ub = negB ? -static_cast<uint128_t>(sb) : sb;
     return negA != negB;
 }
 
@@ -64,50 +64,64 @@
     uint128_t b;
     bool negative = output_sign(_v, o._v, a, b);
     uint128_t result = Umul(a, b);
-    _v = negative ? -result : result;
+    if (negative)
+    {
+        NS_ASSERT_MSG(result <= HP128_MASK_HI_BIT, "overflow detected");
+        _v = -result;
+    }
+    else
+    {
+        NS_ASSERT_MSG(result < HP128_MASK_HI_BIT, "overflow detected");
+        _v = result;
+    }
 }
 
 uint128_t
 int64x64_t::Umul(const uint128_t a, const uint128_t b)
 {
-    uint128_t aL = a & HP_MASK_LO;
-    uint128_t bL = b & HP_MASK_LO;
-    uint128_t aH = (a >> 64) & HP_MASK_LO;
-    uint128_t bH = (b >> 64) & HP_MASK_LO;
-
-    uint128_t result;
-    uint128_t hiPart;
-    uint128_t loPart;
-    uint128_t midPart;
-    uint128_t res1;
-    uint128_t res2;
-
-    // Multiplying (a.h 2^64 + a.l) x (b.h 2^64 + b.l) =
-    //             2^128 a.h b.h + 2^64*(a.h b.l+b.h a.l) + a.l b.l
-    // get the low part a.l b.l
-    // multiply the fractional part
-    loPart = aL * bL;
-    // compute the middle part 2^64*(a.h b.l+b.h a.l)
-    midPart = aL * bH + aH * bL;
-    // compute the high part 2^128 a.h b.h
-    hiPart = aH * bH;
-    // if the high part is not zero, put a warning
-    NS_ABORT_MSG_IF((hiPart & HP_MASK_HI) != 0,
-                    "High precision 128 bits multiplication error: multiplication overflow.");
-
-    // Adding 64-bit terms to get 128-bit results, with carries
-    res1 = loPart >> 64;
-    res2 = midPart & HP_MASK_LO;
-    result = res1 + res2;
-
-    res1 = midPart >> 64;
-    res2 = hiPart & HP_MASK_LO;
-    res1 += res2;
-    res1 <<= 64;
+    uint128_t al = a & HP_MASK_LO;
+    uint128_t bl = b & HP_MASK_LO;
+    uint128_t ah = a >> 64;
+    uint128_t bh = b >> 64;
+
+    // Let Q(x) be the unsigned Q64.64 fixed point value represented by the uint128_t x:
+    //     Q(x) * 2^64 = x = xh * 2^64 + xl.
+    // (Defining x this way avoids ambiguity about the meaning of the division operators in
+    //     Q(x) = x / 2^64 = xh + xl / 2^64.)
+    // Then
+    //     Q(a) = ah + al / 2^64
+    // and
+    //     Q(b) = bh + bl / 2^64.
+    // We need to find uint128_t c such that
+    //     Q(c) = Q(a) * Q(b).
+    // Then
+    //     c = Q(c) * 2^64
+    //       = (ah + al / 2^64) * (bh + bl / 2^64) * 2^64
+    //       = (ah * 2^64 + al) * (bh * 2^64 + bl) / 2^64
+    //       = ah * bh * 2^64 + (ah * bl + al * bh) + al * bl / 2^64.
+    // We compute the last part of c by (al * bl) >> 64 which truncates (instead of rounds)
+    // the LSB. If c exceeds 2^127, we might assert. This is because our caller
+    // (Mul function) will not be able to represent the result.
 
-    result += res1;
+    uint128_t res = (al * bl) >> 64;
+    {
+        // ah, bh <= 2^63 and al, bl <= 2^64 - 1, so mid < 2^128 - 2^64 and there is no
+        // integer overflow.
+        uint128_t mid = ah * bl + al * bh;
+        // res < 2^64, so there is no integer overflow.
+        res += mid;
+    }
+    {
+        uint128_t high = ah * bh;
+        // If high > 2^63, then the result will overflow.
+        NS_ASSERT_MSG(high <= (static_cast<uint128_t>(1) << 63), "overflow detected");
+        high <<= 64;
+        NS_ASSERT_MSG(res + high >= res, "overflow detected");
+        // No overflow since res, high <= 2^127 and one of res, high is < 2^127.
+        res += high;
+    }
 
-    return result;
+    return res;
 }
 
 void
@@ -189,7 +203,7 @@
 int64x64_t::MulByInvert(const int64x64_t& o)
 {
     bool negResult = _v < 0;
-    uint128_t a = negResult ? -_v : _v;
+    uint128_t a = negResult ? -static_cast<uint128_t>(_v) : _v;
     uint128_t result = UmulByInvert(a, o._v);
 
     _v = negResult ? -result : result;
@@ -198,21 +212,25 @@
 uint128_t
 int64x64_t::UmulByInvert(const uint128_t a, const uint128_t b)
 {
-    uint128_t result;
-    uint128_t ah;
-    uint128_t bh;
-    uint128_t al;
-    uint128_t bl;
-    uint128_t hi;
-    uint128_t mid;
-    ah = a >> 64;
-    bh = b >> 64;
-    al = a & HP_MASK_LO;
-    bl = b & HP_MASK_LO;
-    hi = ah * bh;
-    mid = ah * bl + al * bh;
+    // Since b is assumed to be the output of Invert(), b <= 2^127.
+    NS_ASSERT(b <= HP128_MASK_HI_BIT);
+
+    uint128_t al = a & HP_MASK_LO;
+    uint128_t bl = b & HP_MASK_LO;
+    uint128_t ah = a >> 64;
+    uint128_t bh = b >> 64;
+
+    // Since ah, bh <= 2^63, high <= 2^126 and there is no overflow.
+    uint128_t high = ah * bh;
+
+    // Since ah, bh <= 2^63 and al, bl < 2^64, mid < 2^128 and there is
+    // no overflow.
+    uint128_t mid = ah * bl + al * bh;
     mid >>= 64;
-    result = hi + mid;
+
+    // Since high <= 2^126 and mid < 2^64, result < 2^127 and there is no overflow.
+    uint128_t result = high + mid;
+
     return result;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/int64x64-128.h ns-3.42/src/core/model/int64x64-128.h
--- ns-3.41/src/core/model/int64x64-128.h	2024-02-09 14:44:07.877790000 -0800
+++ ns-3.42/src/core/model/int64x64-128.h	2024-05-29 15:29:46.932073000 -0700
@@ -58,8 +58,6 @@
     static const uint128_t HP128_MASK_HI_BIT = (((int128_t)1) << 127);
     /// Mask for fraction part.
     static const uint64_t HP_MASK_LO = 0xffffffffffffffffULL;
-    /// Mask for sign + integer part.
-    static const uint64_t HP_MASK_HI = ~HP_MASK_LO;
     /**
      * Floating point value of HP_MASK_LO + 1.
      * We really want:
@@ -190,11 +188,6 @@
         _v <<= 64;
     }
 
-    inline int64x64_t(const int128_t v)
-        : _v(v)
-    {
-    }
-
     /**@}*/
 
     /**
@@ -403,7 +396,9 @@
 
     friend inline int64x64_t operator-(const int64x64_t& lhs)
     {
-        return int64x64_t(-lhs._v);
+        int64x64_t res;
+        res._v = -lhs._v;
+        return res;
     }
 
     friend inline int64x64_t operator!(const int64x64_t& lhs)
@@ -415,6 +410,7 @@
 
     /**
      * Implement `*=`.
+     * We assert if the product cannot be encoded in int64x64_t.
      *
      * \param [in] o The other factor.
      */
@@ -430,7 +426,7 @@
      *
      * Mathematically this should produce a Q128.128 value;
      * we keep the central 128 bits, representing the Q64.64 result.
-     * We assert on integer overflow beyond the 64-bit integer portion.
+     * We might assert if the result, in uint128_t format, exceeds 2^127.
      *
      * \param [in] a First factor.
      * \param [in] b Second factor.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/int64x64.cc ns-3.42/src/core/model/int64x64.cc
--- ns-3.41/src/core/model/int64x64.cc	2024-02-09 14:44:07.877790000 -0800
+++ ns-3.42/src/core/model/int64x64.cc	2024-05-29 15:29:46.932073000 -0700
@@ -23,6 +23,7 @@
 
 #include <iomanip> // showpos
 #include <iostream>
+#include <limits>
 #include <sstream>
 #include <stdint.h>
 
@@ -69,9 +70,19 @@
 operator<<(std::ostream& os, const int64x64_t& value)
 {
     const bool negative = (value < 0);
-    const int64x64_t absVal = (negative ? -value : value);
 
-    int64_t hi = absVal.GetHigh();
+    uint64_t hi;
+    int64x64_t low;
+    if (value != int64x64_t(std::numeric_limits<int64_t>::min(), 0))
+    {
+        const int64x64_t absVal = (negative ? -value : value);
+        hi = absVal.GetHigh();
+        low = int64x64_t(0, absVal.GetLow());
+    }
+    else
+    {
+        hi = static_cast<uint64_t>(1) << 63;
+    }
 
     // Save stream format flags
     auto precision = static_cast<std::size_t>(os.precision());
@@ -84,7 +95,6 @@
     std::ostringstream oss;
     oss << hi << "."; // collect the digits here so we can round properly
 
-    int64x64_t low(0, absVal.GetLow());
     std::size_t places = 0; // Number of decimal places printed so far
     bool more = true;       // Should we print more digits?
 
